// SobelFilter.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

//vWFNg̃vpeBC/C++ˑSʁ@̒ǉ̃CN[hfBNg
// wC:\OpenCV2.2\includexǉ̂
#include "opencv2\\opencv.hpp"
 
#ifdef _DEBUG
    //Debug[h̏ꍇ
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_core220d.lib")
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_imgproc220d.lib")
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_highgui220d.lib")
#else
    //Release[h̏ꍇ
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_core220.lib")
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_imgproc220.lib")
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_highgui220.lib")
#endif

//---------------------------------------------------------------  
//y֐@zFcv_Sobel  
//yTvzF\[xtB^  
//y@@zFsrc        = ͉摜i8bitj 
//@@@@@@Fdst        = o͉摜i8bitj
//y߂l@zFȂ  
//yl@@zF
//---------------------------------------------------------------   
void cv_Sobel(IplImage* src, IplImage* dst){

    IplImage* xSoble  = cvCreateImage(cvGetSize(src), IPL_DEPTH_16S, src->nChannels);
    IplImage* ySoble  = cvCreateImage(cvGetSize(src), IPL_DEPTH_16S, src->nChannels);
    IplImage* xySoble = cvCreateImage(cvGetSize(src), IPL_DEPTH_16S, src->nChannels);

    //X̃\[x
    cvSobel(src, xSoble, 1, 0);
    //Ỹ\[x
    cvSobel(src, ySoble, 0, 1);

    //X + Y
    cvAdd(xSoble, ySoble, xySoble);

    //t16rbgȂ8rbg
    cvConvertScaleAbs(xySoble, dst);

    //
    cvReleaseImage(&xSoble);
    cvReleaseImage(&ySoble);
    cvReleaseImage(&xySoble);

}

int _tmain(int argc, _TCHAR* argv[])
{

	//摜f[^̓ǍiO[XP[œǍj
	IplImage* src = cvLoadImage("Lenna.bmp", CV_LOAD_IMAGE_GRAYSCALE);
	if (src == NULL){
		return 0;
	}
 
	//\EBhE̍쐬
	cvNamedWindow("src");
	cvNamedWindow("dst");
 
	//摜f[^̊m
	IplImage* dst = cvCreateImage(cvGetSize(src), src->depth, src->nChannels);
 
	//\[xtB^
	cv_Sobel(src, dst);
 
	//摜̕\
	cvShowImage ("src", src);
	cvShowImage ("dst", dst);
 
	//L[͑҂
	cvWaitKey (0);
 
	//SẴEBhE̍폜
	cvDestroyAllWindows();
 
	//摜f[^̉
	cvReleaseImage(&src);
	cvReleaseImage(&dst);

	return 0;
}

